<template>
    <div ref="addButton" class="add-button editor">
        <div @click="handleClick" ref="overlay" class="overlay"></div>
        <div class="actions">
            <button
                @click="handleCreateNotebook"
                ref="addNotebook"
                class="add-notebook action"
                style="opacity: 0; transform: translateY(300px)"
            >
                <span class="title">Notebook</span>
                <span class="icon">
                    <app-icon size="2x" icon="book"></app-icon>
                </span>
            </button>

            <button
                @click="handleCreateNote"
                ref="addNote"
                class="add-note action"
                style="opacity: 0; transform: translateY(300px)"
            >
                <span class="title">Note</span>
                <span class="icon">
                    <app-icon size="2x" icon="sticky-note"></app-icon>
                </span>
            </button>
            <button
                @click="handleCreateTag"
                ref="addTag"
                class="add-note action"
                style="opacity: 0; transform: translateY(300px)"
            >
                <span class="title">Tag</span>
                <span class="icon">
                    <app-icon size="2x" icon="tags"></app-icon>
                </span>
            </button>
        </div>
        <div class="buttons">
            <button @click="handleClick">
                <span v-if="!open" class="open">
                    <app-icon size="2x" icon="plus"></app-icon>
                </span>
                <span v-else class="close">
                    <app-icon size="lg" icon="minus"></app-icon>
                </span>
            </button>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { State } from 'vuex-class'
import { Watch } from 'vue-property-decorator'
import anime, { AnimeParams } from 'animejs'
import { AddButtonRefs } from '@/app/Editor/types/addButton'
import { INotebookState, INotebook } from '../../../../store/types/notebooks'
import { IRoot } from '../../../../store/types/root'

@Component
export default class AddButtonNode extends Vue {
    // Lifecycles
    mounted() {
        const { overlay, addNotebook, addNote, addButton, addTag } = this
            .$refs as AddButtonRefs
        this.overlay = overlay
        this.actions = [addNotebook, addNote, addTag]
        this.addButton = addButton
    }

    // Data

    open: boolean = false
    addButton: Element | undefined
    actions: Element[] | undefined
    overlay: Element | undefined
    animationSettings: AnimeParams = {
        duration: 250,
        easing: 'cubicBezier(0.4,0.0,0.2,1)',
    }

    @State((state: IRoot) => {
        if (!state.Notebooks) return undefined
        return state.Notebooks.currentNotebook
    })
    currentNotebook: INotebook | undefined

    // Watchers
    @Watch('open')
    watchOpen(newOpenState: boolean) {
        if (newOpenState) {
            // if true
            if (this.actions && this.overlay) {
                if (this.addButton) this.addButton.classList.add('open')
                this.initStateActions(this.actions)
                this.initStateOverlay(this.overlay)
            }
        } else {
            // if false
            if (this.actions && this.overlay) {
                this.leaveActiveActions(this.actions)
                this.leaveActiveOverlay(this.overlay)
            }
        }
    }

    // Methods

    handleClick() {
        this.open = !this.open
    }

    handleCreateNotebook() {
        this.$emit('createNotebook', true)
        this.open = !this.open
    }

    handleCreateNote() {
        const Notebook = this.currentNotebook
        if (Notebook && Notebook.id) {
            this.$router.push({
                name: 'note',
                params: {
                    NotebookID: Notebook.id,
                    NoteID: 'new-note',
                },
            })
        }
    }

    handleCreateTag() {
        this.$emit('createTag', true)
        this.open = !this.open
    }

    // SPECIAL

    // Animation

    // 1. Actions

    initStateActions(els: Element[]) {
        this.enterActiveActions(els)
    }

    enterActiveActions(els: Element[]) {
        anime({
            targets: els,
            opacity: 1,
            translateY: 0,
            delay: anime.stagger(100),
            ...this.animationSettings,
        })
    }

    leaveActiveActions(els: Element[]) {
        anime({
            targets: els,
            opacity: 0,
            translateY: 300,
            delay: anime.stagger(100),
            ...this.animationSettings,
        })
    }

    // 2. Overlay

    initStateOverlay(el: Element) {
        this.enterActiveOverlay(el)
    }

    enterActiveOverlay(el: Element) {
        anime({
            targets: el,
            opacity: 0.35,
            ...this.animationSettings,
        })
    }

    leaveActiveOverlay(el: Element) {
        anime({
            targets: el,
            opacity: 0,
            ...this.animationSettings,
            complete: () => {
                if (this.addButton) this.addButton.classList.remove('open')
            },
        })
    }
}
</script>